<template>
  <el-form ref="form" :model="form" :rules="rules">
    <ele-pro-table
      ref="table"
      :needPage="false"
      :columns="columns"
      max-height="500px"
      :toolkit="[]"
      :datasource="form.datasource"
      cache-key="systemRoleTable17"
      class="time-form"
    >
      <!-- 表头工具栏 -->
      <template v-slot:toolbar>
        <div class="headbox">
          <div>
<!--            <el-button-->
<!--              size="small"-->
<!--              type="primary"-->
<!--              icon="el-icon-plus"-->
<!--              class="ele-btn-icon"-->
<!--              @click="handlAdd"-->
<!--            >-->
<!--              新增-->
<!--            </el-button>-->
            <el-button
              size="small"
              type="primary"
              icon="el-icon-plus"
              class="ele-btn-icon"
              @click="handParent('',-1)"
            >
              新增
            </el-button>
          </div>
        </div>
      </template>
      <template v-slot:productName="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.productName'"
          :rules="{
            required: true,
            message: '请输入',
            trigger: 'change'
          }"
        >
          <el-input
            v-model="row.productName"
            placeholder="请输入"
            style="width: 60%; margin-right: 10px"
            :disabled="!!row.productCode||isNeedInquiry===0"
          ></el-input>
          <el-button
            size="small"
            type="primary"
            @click.native="handParent(row, $index)"
          >选择
          </el-button
          >
        </el-form-item>
      </template>
      <template v-slot:productCode="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.productCode'"
        >
          <el-input v-model="scope.row.productCode" disabled></el-input>
        </el-form-item>
      </template>
      <template v-slot:productCategoryName="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.productCategoryName'"
        >
          <el-input v-model="scope.row.productCategoryName" disabled></el-input>
        </el-form-item>
      </template>
      <template v-slot:totalCount="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.totalCount'"
          :rules="{
            required: true,
            pattern: numberReg,
            message: '请输入数字',
            trigger: 'blur'
          }"
        >
          <el-input
            v-model="scope.row.totalCount"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>

      <template v-slot:productBrand="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.productBrand'"
        >
          <el-input
            v-model="scope.row.productBrand"
            :disabled="!!scope.row.productCode"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:brand="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.brand'"
        >
          <el-input v-model="scope.row.brand"></el-input>
        </el-form-item>
      </template>

      <template v-slot:modelType="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.modelType'"
        >
          <el-input
            v-model="scope.row.modelType"
            :disabled="!!scope.row.productCode"
          ></el-input>
        </el-form-item>
      </template>

      <template v-slot:specification="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.specification'"
        >
          <el-input
            v-model="scope.row.specification"
            :disabled="!!scope.row.productCode"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:measuringUnit="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.measuringUnit'"
        >
          <el-input
            v-model="scope.row.measuringUnit"
            placeholder="请输入"
            :disabled="!!scope.row.productCode"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:remark="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.remark'"
        >
          <el-input
            v-model="scope.row.remark"
            type="textarea"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>

      <template v-slot:technicalAnswerName="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.technicalAnswerName'"
          :rules="{
            required: false,
            message: '请输入',
            trigger: 'change'
          }"
        >
          <el-input
            v-model="row.technicalAnswerName"
            placeholder="请输入"
            @click.native="handHead(row, $index)"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:technicalParams="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.technicalParams'"
          :rules="{
            required: false,
            message: '请输入',
            trigger: 'change'
          }"
        >
          <el-input
            type="textarea"
            v-model="scope.row.technicalParams"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:files="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.files'"
        >
          <fileUpload
            v-model="scope.row.files"
            module="main"
            :showLib="false"
            :limit="5"
          />
        </el-form-item>
      </template>
      <template v-slot:technicalDrawings="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.technicalDrawings'"
        >
          <fileUpload
            v-model="scope.row.technicalDrawings"
            module="main"
            :showLib="false"
            :limit="5"
          />
        </el-form-item>
      </template>

      <template v-slot:expectReceiveDate="scope">
        <el-form-item
          v-if="scope.row.arrivalWay == 1"
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.expectReceiveDate'"
          :rules="{
            required: true,
            message: '请选择日期',
            trigger: 'blur'
          }"
        >
          <el-date-picker
            style="width: 100%"
            clearable
            v-model="scope.row.expectReceiveDate"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="请选择日期"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item
          style="margin-bottom: 20px"
          v-if="scope.row.arrivalWay == 2"
        >
          <el-link
            type="primary"
            :underline="false"
            @click.native="handleMethod(scope.row,scope.$index)"
          >
            设置分批时间
          </el-link>
        </el-form-item>
      </template>
      <template v-slot:arrivalWay="scope">
        <el-form-item
          :prop="'datasource.' + scope.$index + '.arrivalWay'"
          :rules="{
            required: true,
            message: '请选择',
            trigger: 'blur'
          }"
        >
          <el-select
            v-model="scope.row.arrivalWay"
            clearable
            style="width: 100%"
          >
            <el-option
              v-for="item in arrivalWayList"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </template>
      <template v-slot:supplierName="scope">
        <el-form-item
          style="margin-bottom: 20px"


          :prop="'datasource.' + scope.$index + '.supplierName'"
          :rules="{
            required: isNeedInquiry===0,
            message: '请选择',
            trigger: 'change'
          }"
        >
          <el-input
            :disabled="isNeedInquiry!==0"
            clearable
            @click.native="(e)=>handleGetSup(e,scope.row,scope.$index)"
            v-model="scope.row.supplierName"
            placeholder="请输入"
          ></el-input>
        </el-form-item>
      </template>

      <template v-slot:headerProductName="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerTotalCount="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerExpectReceiveDate="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerArrivalWay="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerSupplierName="{ column }">
        <span :class="{'is-required':isNeedInquiry===0}">{{ column.label }}</span>
      </template>

      <!-- 操作列 -->
      <template v-slot:action="scope">
        <el-popconfirm
          class="ele-action"
          title="确定要删除吗？"
          @confirm="remove(scope.$index)"
        >
          <template v-slot:reference>
            <el-link type="danger" :underline="false" icon="el-icon-delete">
              删除
            </el-link>
          </template>
        </el-popconfirm>
      </template>
    </ele-pro-table>
    <product-list
      ref="productListRef"
      classType="1"
      :is-get-inventory-total="true"
      @changeParent="changeParent"
      :is-show-c-bom="true"
      @getSelectionCbom="getSelectionCbom"
    ></product-list>
    <head-list ref="headRef" @changeParent="changeAnswer"></head-list>
    <timeDialog @chooseTime="chooseTime" ref="timeDialogRef"></timeDialog>
    <supplierList
      ref="supplierListRef"
      :classType="2"
      @changeParent="getSupInfo"
    ></supplierList>
  </el-form>
</template>
<script>
import {numberReg} from 'ele-admin';
import productList from '@/BIZComponents/product-list.vue';
import dictMixins from '@/mixins/dictMixins';
import fileUpload from '@/components/upload/fileUpload';
import headList from '@/views/saleManage/businessOpportunity/components/headList.vue';
import timeDialog from '@/components/timeDialog/index.vue';
import {copyObj} from '@/utils/util';
import supplierList from "@/views/purchasingManage/supplierManage/components/parentList.vue";
import {getInventoryTotalAPI} from "@/api/wms";
import {getByCode} from "@/api/system/dictionary-data";

export default {
  mixins: [dictMixins],
  props: {
    needInquiry: {
      type: Number,
      default: 1
    }
  },
  components: {
    supplierList,
    productList,
    fileUpload,
    headList,
    timeDialog
  },
  computed: {
    isNeedInquiry() {
      if (this.needInquiry === 1) {
        this.form.datasource.forEach(item => {
          item.supplierCode = ''
          item.supplierId = ''
          item.supplierName = ''
        })
      }
      return this.needInquiry
    }
  },
  data() {
    const defaultForm = {
      key: null,
      endTime: '',
      isFirst: 0,
      name: '',
      supplierName: '',
      weightUnit: '',
    };
    return {
      curIndex: null,
      numberReg,
      defaultForm,
      arrivalWayList: [
        {label: '一次性到货', value: 1},
        {label: '分批到货', value: 2}
      ],
      form: {
        datasource: []
      },
      rules: {},
      dictList: {},
      columns: [
        {
          width: 45,
          type: 'index',
          columnKey: 'index',
          align: 'center'
        },
        {
          width: 150,
          prop: 'productCategoryName',
          label: '分类',
          slot: 'productCategoryName',
          align: "center"
        },
        {
          width: 140,
          prop: 'productCode',
          label: '编码',
          slot: 'productCode',
          align: "center"
        },
        {
          width: 240,
          prop: 'productName',
          label: '名称',
          slot: 'productName',
          headerSlot: 'headerProductName',
          align: "center"
        },
        {
          width: 150,
          prop: 'productBrand',
          label: '牌号',
          slot: 'productBrand',
          align: "center"
        },
        {
          width: 130,
          prop: 'modelType',
          label: '型号',
          slot: 'modelType',
          align: "center"
        },

        {
          width: 120,
          prop: 'specification',
          label: '规格',
          slot: 'specification',
          align: "center"
        },
        {
          width: 120,
          prop: 'imgCode',
          align: 'center',
          label: '图号/件号',
          showOverflowTooltip: true
        },
        {
          width: 120,
          prop: 'produceType',
          align: 'center',
          label: '生产类型',
          showOverflowTooltip: true,
          formatter: (row, column) => {
            return row.produceType&&row.produceType.length ? row.produceType.map(item => this.getDictV('productionType', item+'')).join(',') : ''
          }
        },
        {
          width: 120,
          prop: 'approvalNumber',
          align: 'center',
          label: '批准文号',
          showOverflowTooltip: true
        },
        {
          width: 120,
          prop: 'packingSpecification',
          align: 'center',
          label: '包装规格',
          showOverflowTooltip: true
        },
        {
          width: 80,
          prop: 'totalCount',
          label: '数量',
          slot: 'totalCount',
          headerSlot: 'headerTotalCount',
          align: "center"
        },
        {
          width: 80,
          prop: 'availableCountBase',
          label: '库存数量',
          slot: 'availableCountBase',
          align: "center"
        },
        {
          width: 100,
          prop: 'measuringUnit',
          label: '单位',
          slot: 'measuringUnit',
          align: "center"
        },

        {
          width: 130,
          prop: 'brand',
          label: '品牌',
          slot: 'brand',
          align: "center"
        },
        {
          width: 130,
          prop: 'supplierName',
          label: '供应商',
          slot: 'supplierName',
          headerSlot: 'headerSupplierName',
          align: "center",
        },
        {
          width: 160,
          prop: 'arrivalWay',
          label: '到货方式',
          slot: 'arrivalWay',
          headerSlot: 'headerArrivalWay',
          align: "center"
        },
        {
          width: 170,
          prop: 'expectReceiveDate',
          label: '到货日期',
          slot: 'expectReceiveDate',
          headerSlot: 'headerExpectReceiveDate',
          align: "center"
        },
        {
          width: 160,
          prop: 'technicalDrawings',
          label: '图纸附件',
          slot: 'technicalDrawings'
        },
        {
          width: 160,
          prop: 'files',
          label: '附件',
          slot: 'files'
        },
        {
          width: 220,
          prop: 'remark',
          label: '备注',
          slot: 'remark',
          align: "center"
        },
        {
          columnKey: 'action',
          label: '操作',
          width: 120,
          align: 'center',
          resizable: false,
          slot: 'action',
          fixed: 'right',
          showOverflowTooltip: true
        }
      ]
    };
  },
  created() {
    this.getDictList('productionType')
  },
  methods: {
    getDictV(code, val) {
      if (!this.dictList[code]) return '';
      return this.dictList[code].find(item => item.value == val)?.label
    },
    async getDictList(code) {
      let {data: res} = await getByCode(code)
      this.dictList[code] = res.map(item => {
        let values = Object.keys(item)
        return {
          value: values[0],
          label: item[values[0]]
        }
      })
    },
    // 返回列表数据
    getTableValue() {
      let comitDatasource = this.form.datasource;
      if (comitDatasource.length === 0) return [];
      comitDatasource.forEach((v) => {
        v.totalPrice = (v.totalCount * v.singlePrice)?.toFixed(2) || 0;
        v.files = v.files || [];
        v.technicalDrawings = v.technicalDrawings || [];
        v.arrivalBatch = v.arrivalBatch || [];
      });
      return comitDatasource;
    },
    //修改回显
    async putTableValue(data) {
      if (data && data?.length) {
        this.form.datasource = []
        data.forEach(row => {
          let item = JSON.parse(JSON.stringify(row));
          item.key = this.form.datasource.length + 1;
          item = {
            ...this.defaultForm,
            ...item
          }
          this.form.datasource.push(item);
        })
        let codeList = this.form.datasource.map(item => item.productCode)
        //获取仓库库存
        let inventoryTotalList = await getInventoryTotalAPI(codeList);
        this.form.datasource.forEach((item) => {
          let find =
            inventoryTotalList.find((key) => key.code == item.productCode) || {};
          item.availableCountBase = find.availableCountBase;
        });
        this.$refs.table.reload()
      }
    },
    handleMethod(row, index) {
      this.curIndex = index
      this.$refs.timeDialogRef.open(row, index);
    },
    chooseTime(row, arrivalBatch) {
      row.arrivalBatch = copyObj(arrivalBatch);
      this.$set(this.form.datasource[this.curIndex], 'arrivalBatch', copyObj(arrivalBatch))
    },
    //获取供应商信息
    handleGetSup(e, row, index) {
      this.curIndex = index
      if (e.target.nodeName == 'I') {
        this.$set(this.form.datasource[this.curIndex], 'supplierCode', '')
        this.$set(this.form.datasource[this.curIndex], 'supplierId', '')
        this.$set(this.form.datasource[this.curIndex], 'supplierName', '')
        return
      }
      let item = {id: row.supplierId};
      this.$refs.supplierListRef.open(item);
    },
    //选择供应商信息回调
    getSupInfo(obj) {
      let params = {
        supplierCode: obj.code,
        supplierId: obj.id,
        supplierName: obj.name,

      }
      this.$set(this.form.datasource[this.curIndex], 'supplierCode', params.supplierCode)
      this.$set(this.form.datasource[this.curIndex], 'supplierId', params.supplierId)
      this.$set(this.form.datasource[this.curIndex], 'supplierName', params.supplierName)

    },
    //选择产品
    handParent(row, index) {
      // let item = {
      //   id: row.productCode
      // };
      this.$refs.productListRef.open(this.form.datasource, index);
    },
    //选择技术人回调
    changeAnswer(obj, idx) {
      this.$set(this.form.datasource[idx], 'technicalAnswerId', obj.id);
      this.$set(this.form.datasource[idx], 'technicalAnswerName', obj.name);
    },
    handHead(row, index) {
      let item = {
        id: row.technicalAnswerId
      };
      this.$refs.headRef.open(item, index);
    },
    getSelectionCbom(obj,idx=-1){
      obj.forEach((item, index) => {
        let i = idx == -1 ? index : idx;
        let row = JSON.parse(JSON.stringify(this.defaultForm));
        row.key = this.form.datasource.length + 1;
        let parasm = idx == -1 ? row : this.form.datasource[i];
        this.$set(parasm, 'productId', item.id);
        // this.$set(parasm, 'id', item.id);
        this.$set(parasm, 'categoryName', item.name);
        this.$set(parasm, 'productCategoryId', item.categoryLevelId);
        this.$set(parasm, 'productBrand', item.brandNum);
        this.$set(parasm, 'productCategoryName', item.category.categoryLevelPath);
        this.$set(parasm, 'totalCount', item.dosage);
        this.$set(parasm, 'productCode', item.code);
        this.$set(parasm, 'productName', item.name);
        this.$set(parasm, 'availableCountBase', item.availableCountBase);
        this.$set(parasm, 'modelType', item.modelType);
        this.$set(parasm, 'weightUnit', item.weightUnit);
        this.$set(parasm, 'measuringUnit', item.unit);
        this.$set(parasm, 'specification', item.specification);
        this.$set(parasm, 'remark', '');
        this.$set(parasm, 'imgCode', item.imgCode);
        this.$set(parasm, 'produceType', item.produceType);
        this.$set(parasm, 'approvalNumber', item.approvalNumber);
        this.$set(parasm, 'packingSpecification', item.packingSpecification);
        if (idx == -1) {
          this.form.datasource.push(row);
        }
      })
    },
    //选择产品回调
    changeParent(obj, idx) {
      obj.forEach((item, index) => {
        let i = idx == -1 ? index : idx;
        let row = JSON.parse(JSON.stringify(this.defaultForm));
        row.key = this.form.datasource.length + 1;
        let parasm = idx == -1 ? row : this.form.datasource[i];
        this.$set(parasm, 'productId', item.id);
        // this.$set(parasm, 'id', item.id);
        this.$set(parasm, 'categoryName', item.name);
        this.$set(parasm, 'productCategoryId', item.categoryLevelId);
        this.$set(parasm, 'productBrand', item.brandNum);
        this.$set(parasm, 'productCategoryName', item.categoryLevelPath);
        this.$set(parasm, 'productCode', item.code);
        this.$set(parasm, 'productName', item.name);
        this.$set(parasm, 'availableCountBase', item.availableCountBase);
        this.$set(parasm, 'modelType', item.modelType);
        this.$set(parasm, 'weightUnit', item.weightUnit);
        this.$set(parasm, 'measuringUnit', item.measuringUnit);
        this.$set(parasm, 'specification', item.specification);
        this.$set(parasm, 'remark', '');
        this.$set(parasm, 'imgCode', item.imgCode);
        this.$set(parasm, 'produceType', item.produceType);
        this.$set(parasm, 'approvalNumber', item.approvalNumber);
        this.$set(parasm, 'packingSpecification', item.packingSpecification);
        if (idx == -1) {
          this.form.datasource.push(row);
        }
      })
    },
    remove(i) {
      this.form.datasource.splice(i, 1);
      this.setSort();
    },
    // 清空表格
    restTable() {
      this.form.datasource = [];
    },
    // 重新排序
    setSort() {
      this.form.datasource.forEach((n, index) => {
        n.key = index + 1;
      });
    },
    // 添加
    handlAdd() {
      let item = JSON.parse(JSON.stringify(this.defaultForm));
      item.key = this.form.datasource.length + 1;
      this.form.datasource.push(item);
    },

    validateForm(callback) {
      //开始表单校验
      this.$refs.form.validate((valid) => {
        callback(valid);
      });
    }
  }
};
</script>
<style lang="scss" scoped>
.headbox {
  display: flex;
  justify-content: space-between;
  align-items: center;

  .amount {
    font-size: 14px;
    font-weight: bold;
  }
}

.time-form .el-form-item {
  margin-bottom: 0 !important;
}

::v-deep .period {
  display: flex;

  .borderleftnone {
    .el-input--medium .el-input__inner {
      border-top-right-radius: 0;
      border-bottom-right-radius: 0;
    }
  }

  .borderrightnone {
    .el-input--medium .el-input__inner {
      border-top-left-radius: 0;
      border-bottom-left-radius: 0;
    }
  }
}

::v-deep .time-form tbody > tr:hover > td {
  background-color: transparent !important;
}

::v-deep .time-form .el-table tr {
  background-color: #ffffff;
}
</style>
